scala.math

# BigDecimal

#### class BigDecimal extends ScalaNumber with ScalaNumericConversions with Serializable

Source
  BigDecimal.scala
Version

  1.0

Linear Supertypes
Serializable, ScalaNumericConversions, ScalaNumber, Number, Serializable, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. BigDecimal
2. Serializable
3. ScalaNumericConversions
4. ScalaNumber
5. Number
6. Serializable
7. AnyRef
8. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new BigDecimal(bigDecimal: BigDecimal)

2. #### new BigDecimal(bigDecimal: BigDecimal, mc: MathContext)

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def %(that: BigDecimal): BigDecimal

   Remainder after dividing this by that.

5. #### def *(that: BigDecimal): BigDecimal

   Multiplication of BigDecimals

6. #### def +(that: BigDecimal): BigDecimal

   Addition of BigDecimals

7. #### def -(that: BigDecimal): BigDecimal

   Subtraction of BigDecimals

8. #### def /(that: BigDecimal): BigDecimal

   Division of BigDecimals

9. #### def /%(that: BigDecimal): (BigDecimal, BigDecimal)

   Division and Remainder - returns tuple containing the result of divideToIntegralValue and the remainder.

10. #### def <(that: BigDecimal): Boolean

    Less-than of BigDecimals

11. #### def <=(that: BigDecimal): Boolean

    Less-than-or-equals comparison of BigDecimals

12. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

13. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

14. #### def >(that: BigDecimal): Boolean

    Greater-than comparison of BigDecimals

15. #### def >=(that: BigDecimal): Boolean

    Greater-than-or-equals comparison of BigDecimals

16. #### def abs: BigDecimal

    Returns the absolute value of this BigDecimal

17. #### def apply(mc: MathContext): BigDecimal

    Returns a new BigDecimal based on the supplied MathContext.

18. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

19. #### val bigDecimal: BigDecimal

20. #### def byteValue(): Byte

    Converts this BigDecimal to a Byte.

    Converts this BigDecimal to a Byte. If the BigDecimal is too big to fit in a Byte, only the low-order 8 bits are returned. Note that this conversion can lose information about the overall magnitude of the BigDecimal value as well as return a result with the opposite sign.

    Definition Classes
      BigDecimal → Number

21. #### def charValue: Char

    Converts this BigDecimal to a Char.

    Converts this BigDecimal to a Char. If the BigDecimal is too big to fit in a char, only the low-order 16 bits are returned. Note that this conversion can lose information about the overall magnitude of the BigDecimal value and that it always returns a positive result.

22. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

23. #### def compare(that: BigDecimal): Int

    Compares this BigDecimal with the specified BigDecimal

24. #### def doubleValue(): Double

    Converts this BigDecimal to a Double.

    Converts this BigDecimal to a Double. if this BigDecimal has too great a magnitude to represent as a double, it will be converted to `Double.NEGATIVE_INFINITY` or `Double.POSITIVE_INFINITY` as appropriate.

    Definition Classes
      BigDecimal → Number

25. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

26. #### def equals(that: BigDecimal): Boolean

    Compares this BigDecimal with the specified BigDecimal for equality.

27. #### def equals(that: Any): Boolean

    Compares this BigDecimal with the specified value for equality.

    Compares this BigDecimal with the specified value for equality.

    that

      the object to compare against this object for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      BigDecimal → AnyRef → Any

28. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

29. #### def floatValue(): Float

    Converts this BigDecimal to a Float.

    Converts this BigDecimal to a Float. if this BigDecimal has too great a magnitude to represent as a float, it will be converted to `Float.NEGATIVE_INFINITY` or `Float.POSITIVE_INFINITY` as appropriate.

    Definition Classes
      BigDecimal → Number

30. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

31. #### def hashCode(): Int

    Returns the hash code for this BigDecimal.

    Returns the hash code for this BigDecimal. Note that this does not use the underlying java object's hashCode because we compare BigDecimals with compareTo which deems 2 == 2.00, whereas in java these are unequal with unequal hashCodes.

    returns

      the hash code value for this object.

    Definition Classes
      BigDecimal → AnyRef → Any

32. #### def intValue(): Int

    Converts this BigDecimal to an Int.

    Converts this BigDecimal to an Int. If the BigDecimal is too big to fit in a char, only the low-order 32 bits are returned. Note that this conversion can lose information about the overall magnitude of the BigDecimal value as well as return a result with the opposite sign.

    Definition Classes
      BigDecimal → Number

33. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

34. #### def isValidByte: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of Byte MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of Byte MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericConversions

35. #### def isValidChar: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of Char MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of Char MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericConversions

36. #### def isValidInt: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of Int MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of Int MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericConversions

37. #### def isValidShort: Boolean

    Returns `true` iff this has a zero fractional part, and is within the range of Short MinValue and MaxValue; otherwise returns `false`.

    Returns `true` iff this has a zero fractional part, and is within the range of Short MinValue and MaxValue; otherwise returns `false`.

    Definition Classes
      ScalaNumericConversions

38. #### def isWhole(): Boolean

    Attributes
      protected[math]
    Definition Classes
      BigDecimal → ScalaNumber

39. #### def longValue(): Long

    Converts this BigDecimal to a Long.

    Converts this BigDecimal to a Long. If the BigDecimal is too big to fit in a char, only the low-order 64 bits are returned. Note that this conversion can lose information about the overall magnitude of the BigDecimal value as well as return a result with the opposite sign.

    Definition Classes
      BigDecimal → Number

40. #### def max(that: BigDecimal): BigDecimal

    Returns the maximum of this and that

41. #### val mc: MathContext

42. #### def min(that: BigDecimal): BigDecimal

    Returns the minimum of this and that

43. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

44. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

45. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

46. #### def pow(n: Int): BigDecimal

    Returns a BigDecimal whose value is this ** n.

47. #### def precision: Int

    Returns the precision of this `BigDecimal`.

48. #### def quot(that: BigDecimal): BigDecimal

    Divide to Integral value.

49. #### def remainder(that: BigDecimal): BigDecimal

    Remainder after dividing this by that.

50. #### def round(mc: MathContext): BigDecimal

    Returns a BigDecimal rounded according to the MathContext settings.

51. #### def scale: Int

    Returns the scale of this `BigDecimal`.

52. #### def setScale(scale: Int, mode: RoundingMode): BigDecimal

53. #### def setScale(scale: Int): BigDecimal

    Returns a `BigDecimal` whose scale is the specified value, and whose value is numerically equal to this BigDecimal's.

54. #### def shortValue(): Short

    Converts this BigDecimal to a Short.

    Converts this BigDecimal to a Short. If the BigDecimal is too big to fit in a Byte, only the low-order 16 bits are returned. Note that this conversion can lose information about the overall magnitude of the BigDecimal value as well as return a result with the opposite sign.

    Definition Classes
      BigDecimal → Number

55. #### def signum: Int

    Returns the sign of this BigDecimal, i.

    Returns the sign of this BigDecimal, i.e. -1 if it is less than 0, +1 if it is greater than 0 0 if it is equal to 0

56. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

57. #### def to(end: BigDecimal, step: BigDecimal): Inclusive[BigDecimal]

    Like `until`, but inclusive of the end value.

58. #### def to(end: BigDecimal): Partial[BigDecimal, Inclusive[BigDecimal]]

    Like `until`, but inclusive of the end value.

59. #### def toBigInt(): BigInt

    Converts this `BigDecimal` to a scala.

    Converts this `BigDecimal` to a scala.BigInt.

60. #### def toBigIntExact(): Option[BigInt]

    Converts this `BigDecimal` to a scala.

    Converts this `BigDecimal` to a scala.BigInt if it can be done losslessly, returning Some(BigInt) or None.

61. #### def toByte: Byte

    Returns the value of this as a Byte.

    Returns the value of this as a Byte. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

62. #### def toByteExact: Byte

    Converts this `BigDecimal` to a Byte, checking for lost information.

    Converts this `BigDecimal` to a Byte, checking for lost information. If this `BigDecimal` has a nonzero fractional part, or is out of the possible range for a Byte result, then a `java.lang.ArithmeticException` is thrown.

63. #### def toChar: Char

    Returns the value of this as a Char.

    Returns the value of this as a Char. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

64. #### def toDouble: Double

    Returns the value of this as a Double.

    Returns the value of this as a Double. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

65. #### def toFloat: Float

    Returns the value of this as a Float.

    Returns the value of this as a Float. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

66. #### def toInt: Int

    Returns the value of this as an Int.

    Returns the value of this as an Int. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

67. #### def toIntExact: Int

    Converts this `BigDecimal` to a Int, checking for lost information.

    Converts this `BigDecimal` to a Int, checking for lost information. If this `BigDecimal` has a nonzero fractional part, or is out of the possible range for an Int result, then a `java.lang.ArithmeticException` is thrown.

68. #### def toLong: Long

    Returns the value of this as a Long.

    Returns the value of this as a Long. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

69. #### def toLongExact: Long

    Converts this `BigDecimal` to a Long, checking for lost information.

    Converts this `BigDecimal` to a Long, checking for lost information. If this `BigDecimal` has a nonzero fractional part, or is out of the possible range for a Long result, then a `java.lang.ArithmeticException` is thrown.

70. #### def toShort: Short

    Returns the value of this as a Short.

    Returns the value of this as a Short. This may involve rounding or truncation.

    Definition Classes
      ScalaNumericConversions

71. #### def toShortExact: Short

    Converts this `BigDecimal` to a Short, checking for lost information.

    Converts this `BigDecimal` to a Short, checking for lost information. If this `BigDecimal` has a nonzero fractional part, or is out of the possible range for a Short result, then a `java.lang.ArithmeticException` is thrown.

72. #### def toString(): String

    Returns the decimal String representation of this BigDecimal.

    Returns the decimal String representation of this BigDecimal.

    returns

      a String representation of the object.

    Definition Classes
      BigDecimal → AnyRef → Any

73. #### def ulp: BigDecimal

    Returns the size of an ulp, a unit in the last place, of this BigDecimal.

74. #### def unary_-: BigDecimal

    Returns a BigDecimal whose value is the negation of this BigDecimal

75. #### def underlying(): BigDecimal

    Definition Classes
      BigDecimal → ScalaNumber

76. #### def unifiedPrimitiveEquals(x: Any): Boolean

    Should only be called after all known non-primitive types have been excluded.

    Should only be called after all known non-primitive types have been excluded. This method won't dispatch anywhere else after checking against the primitives to avoid infinite recursion between equals and this on unknown "Number" variants.

    Additionally, this should only be called if the numeric type is happy to be converted to Long, Float, and Double. If for instance a BigInt much larger than the Long range is sent here, it will claim equality with whatever Long is left in its lower 64 bits. Or a BigDecimal with more precision than Double can hold: same thing. There's no way given the interface available here to prevent this error.

    Attributes
      protected
    Definition Classes
      ScalaNumericConversions

77. #### def unifiedPrimitiveHashcode(): Int

    Attributes
      protected
    Definition Classes
      ScalaNumericConversions

78. #### def until(end: BigDecimal, step: BigDecimal): Exclusive[BigDecimal]

    Same as the one-argument `until`, but creates the range immediately.

79. #### def until(end: BigDecimal): Partial[BigDecimal, Exclusive[BigDecimal]]

    Creates a partially constructed NumericRange[BigDecimal] in range `[start;end)`, where start is the target BigDecimal.

    Creates a partially constructed NumericRange[BigDecimal] in range `[start;end)`, where start is the target BigDecimal. The step must be supplied via the "by" method of the returned object in order to receive the fully constructed range. For example:

        val partial = BigDecimal(1.0) to 2.0       // not usable yet
        val range = partial by 0.01                // now a NumericRange
        val range2 = BigDecimal(0) to 1.0 by 0.01  // all at once of course is fine too

    end

      the end value of the range (exclusive)

    returns

      the partially constructed NumericRange

80. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

81. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

82. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from Serializable

### Inherited from ScalaNumericConversions

### Inherited from ScalaNumber

### Inherited from Number

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any